#<profile4xi profile = "12" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "format4xi.py">
#<abstract4xi abstract = "provides function format4xi and class Format4Xi"/>
#<refer4xi reference = "print4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'format4xi', 'Format4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global FormatKB2Xi

FormatKB2Xi = {}
#"
#/>


 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "format4xi" usage = "
#   formatting order numbers to XML messages
#
#   print4xi.py does NOT use this function but instead its embedded format as follows:
#       key2counter = '<order4xi>#' + format(c2xi) + '</order4xi>'
#"> 
# -------------------------------------------------------------------------------------------------
def format4xi(dictionary = {'add-with-leading-zeros': 0}):
    '''
    formats
    '''
    global FormatKB2Xi   
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/4)
    # ---------------------------------------------------------------------------------------------      
    class2print = 'format4xi'
    method2print = 'format4xi'
    
    message2print = "{(Step 1/4a) started" + "; format4xi-started: " + str(dictionary)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/4b) passed" + "; dictionary-passed-to-format4xi: " + str(dictionary) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
    # ---------------------------------------------------------------------------------------------    
    # (Step 2/4)
    # ---------------------------------------------------------------------------------------------             
    formatted2xi = None  

    message2print = "{(Step 2/4a) initialized" + "; formatted2xi-initialized-by-format4xi to: " + str(formatted2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                
        
    number2xi = 0

    message2print = "{(Step 2/4b) initialized" + "; number2xi-initialized-by-format4xi to: " + str(number2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
      
    dictionary2xi = dictionary  #{'add-with-leading-zeros': 5}
                                #{'add-with-leading-zeros': -333}

    message2print = "{(Step 2/4c) initialized" + "; dictionary2xi-initialized-by-format4xi to: " + str(dictionary2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
                                     
    
    keys2dictionary = dictionary2xi.keys()   
                                   

    message2print = "{(Step 2/4d) initialized" + "; keys2dictionary-initialized-by-format4xi to: " + str(keys2dictionary)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
      
    # ---------------------------------------------------------------------------------------------    
    # (Step 3/4)
    # --------------------------------------------------------------------------------------------- 
                  
    if 'add-with-leading-zeros' in keys2dictionary:
    
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
        
        schema2xi = {
        0:'000000000',
        10:'00000000',
        100:'0000000',
        1000:'000000',
        10000:'00000',
        1000000:'000',
        10000000:'00',    
        100000000:'0'}
        
        message2print = "{(Step 3/4a1) set" + "; schema2xi-set-by-format4xi to: " + str(schema2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
            
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
    
        number2xi = dictionary2xi['add-with-leading-zeros']  #5, -333
        
        message2print = "{(Step 3/4a2) set" + "; number2xi-set-by-format4xi to: " + str(number2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
            
        
        abs2xi = abs(number2xi)
    
        
        message2print = "{(Step 3/4a3) set" + "; abs2xi-set-by-format4xi to: " + str(abs2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
    
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
            
        if abs2xi > 0:
    
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
             
            keys2schema = schema2xi.keys()           
            
            message2print = "{(Step 3/4a4) set" + "; keys2schema-set-by-format4xi to: " + str(keys2schema)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
                
            for key2schema in sorted(keys2schema):       
                    
                message2print = "{(Step 3/4a5) using" + "; key2schema-using-by-format4xi: " + str(key2schema)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                       

              
                if abs2xi >= key2schema:                              # 10,100,1000...
                    
                    # -------------------------------------------------------------------------------    
                    #
                    # ------------------------------------------------------------------------------- 
                                  
                    pass
                else: 
                    
                    # -------------------------------------------------------------------------------    
                    #
                    # ------------------------------------------------------------------------------- 
                    # 5 < 10
                    formatted2xi = schema2xi[key2schema] + str(abs2xi) # 000000005
                        
            
                    message2print = "{(Step 3/4a6) set" + "; formatted2xi-set-by-format4xi to: " + str(formatted2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                        
     
   
                    break                    
        else:
    
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
             
            formatted2xi = str(abs2xi)
            
            message2print = "{(Step 3/4a7) set" + "; formatted2xi-set-by-format4xi to: " + str(formatted2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
        
        if number2xi == 0:
    
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
             
            formatted2xi = '000000000'
            
            message2print = "{(Step 3/4a8) set" + "; formatted2xi-set-by-format4xi to: " + str(formatted2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                   
        else:
    
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
             
            if (formatted2xi is None):
                
                # ---------------------------------------------------------------------------------    
                #
                # --------------------------------------------------------------------------------- 
     
                if number2xi < 0:
                
                    # -----------------------------------------------------------------------------    
                    #
                    # ----------------------------------------------------------------------------- 
                     
                    formatted2xi = str(number2xi)
            
                    message2print = "{(Step 3/4a9) set" + "; formatted2xi-set-by-format4xi to: " + str(formatted2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                        
                else:
                
                    # -----------------------------------------------------------------------------    
                    #
                    # ----------------------------------------------------------------------------- 
                      
                    formatted2xi = str(number2xi)
            
                    message2print = "{(Step 3/4a10) set" + "; formatted2xi-set-by-format4xi to: " + str(formatted2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
    
            else:
                
                # ---------------------------------------------------------------------------------    
                #
                # --------------------------------------------------------------------------------- 
                 
                if number2xi < 0:
                    formatted2xi = '-' + str(formatted2xi) 
 
                    message2print = "{(Step 3/4a11) set" + "; formatted2xi-set-by-format4xi to: " + str(formatted2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
 
  
    
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
    

        FormatKB2Xi[number2xi] = formatted2xi        
            
        message2print = "{(Step 3/4a12) set" + "; FormatKB2Xi-set-by-format4xi to: " + str(FormatKB2Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
      
    else:
    
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
    
        formatted2xi = '000000000'
        
        message2print = "{(Step 3/4b) set" + "; formatted2xi-set-by-format4xi to: " + str(formatted2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
          
      
    # ---------------------------------------------------------------------------------------------    
    # (Step 4/4)
    # --------------------------------------------------------------------------------------------- 
            
    return formatted2xi
#</function4xi> 
                
# =================================================================================================
#<class4xi class = "Format4Xi" base = "object" child = "None"
#   synopsis = "offers services for formatting"
#   usage = "
#       test_format4xi.py:
#           f2xi = Format4Xi()
#           num2xi = 0                  # command
#           c2xi = {cmd2xi: num2xi}     # value
#           print(f2xi.format(c2xi))    # context        
#       print4xi.py does NOT use this function but instead its embedded format, which has been tested with format4xi.py
#           key2counter = '<order4xi>#' + format(c2xi) + '</order4xi>'
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class Format4Xi(object): #<-- inherits from object class
    '''
    Format4Xi offers services for formatting
    '''            

    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = "
    _exposed_ = ('format', 'sense', 'reason', 'ace')          
    #"
    #/>
                
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Format4Xi" usage = "initializes Format4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def __init__(self):
        '''
        initializes Format4Xi
        '''
               
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
               
        class2print = 'Format4Xi'
        method2print = '__init__'
        
        message2print = "{started" + "; init-of-Format4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                                
        
        message2print = "{borning" + "; format2xi-of-Format4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{inheriting" + "; object-inheriting-by-format2xi-of-Format4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                               
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{inherited" + "; object-inherited-by-format2xi-of-Format4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                                   
        message2print = "{activated" + "; format2xi-of-Format4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
      
        message2print = "{returning" + "; init-of-Format4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
                
                                            
    #</methodize4xi>
     

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "format-of-Format4Xi" usage = "formats">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def format(self, format = {}):
        '''
        formats
        '''       
               
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
      
        class2print = 'Format4Xi'
        method2print = 'format'
        
    
        message2print = "{started" + "; format-of-Format4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     

        message2print = "{passed" + "; format-passed-to-format-of-Format4Xi: " + str(format) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
               
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
          
        message2print = "{returning" + "; format4xi-returning-by-format-of-Format4Xi: " + str(format4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
        return format4xi(format) 
    #</methodize4xi>
            
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Format4Xi" usage = "senses Format4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Format4Xi class objects
        '''
               
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        class2print = 'Format4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-Format4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; Format4Xi-sensing-by-sense-of-Format4Xi: " + str(Format4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                   
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-Format4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
                
                
        
                        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
    
        
        
      
        message2print = "{sensed" + "; Format4Xi-sensed-by-sense-of-Format4Xi: " + str(Format4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-Format4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
                                  
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Format4Xi" usage = "reasons Format4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Format4Xi class objects
        '''
               
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        class2print = 'Format4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-Format4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; Format4Xi-reasoning-by-reason-of-Format4Xi: " + str(Format4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-Format4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
                        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; Format4Xi-reasoned-by-reason-of-Format4Xi: " + str(Format4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
         
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-Format4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                         
                                  
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Format4Xi" usage = "aces Format4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Format4Xi class objects 
        '''
               
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
                     
        
        
        class2print = 'Format4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-Format4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; Format4Xi-acing-by-ace-of-Format4Xi: " + str(Format4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-Format4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
                

        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; Format4Xi-aced-by-ace-of-Format4Xi: " + str(Format4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-Format4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
                                
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# sense-test-format4xi.xml
# reason-test-format4xi.xml
# ace-test-format4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of format4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>          


